from distutils import util

from django.db.models import Prefetch
from rest_framework import permissions, viewsets, status
from rest_framework.exceptions import PermissionDenied, NotFound
from rest_framework.permissions import IsAuthenticated
from rest_framework.response import Response
from rest_framework.decorators import action

from commons.filter.collection_filter import CollectionFilterBackend
from commons.mixins import ExtraActionsMixin
from commons.permissions import is_admin
from commons.utils import LazyModelCollection, ModelCollection
from lods.factories.lab_factory import ILabsFactory
from lods.models import Series, Course, Lab, LabHistory
from commons.dependency_injection import inject
from lods.serializers import SeriesSerializer, CourseSerializer, LaunchSerializer, LabSerializer, \
    CourseExtendedSerializer, SeriesExtendedSerializer, LabHistorySerializer

import logging

from lods.services.launch_course_service import ILaunchCourseService
from lods.services.destroy_lab_service import IDestroyLabService, DestroyLabService
from lods.services.resume_lab_service import IResumeLabService
from lods.services.save_lab_service import ISaveLabService

logger = logging.getLogger(__name__)


class SeriesViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = Series.objects.filter(deleted=False).prefetch_related(Prefetch(
        'courses', queryset=Course.objects.filter(deleted=False)))

    def get_serializer_class(self):
        extended_raw = self.request.query_params.get('extended', "False")
        extended = bool(util.strtobool(extended_raw))
        if extended:
            return SeriesExtendedSerializer
        return SeriesSerializer


# this order of inheritance is needed to overwrite (patch) the method get_extra_action_url_map
class CourseViewSet(ExtraActionsMixin, viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = Course.objects.filter(deleted=False)
    filterset_fields = ['series_id']

    @inject
    def __init__(self, launch_course_service: ILaunchCourseService, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.launch_course_service = launch_course_service

    def get_serializer_class(self):
        self.get_queryset()
        if self.action == "launch":
            return LaunchSerializer
        extended_raw = self.request.query_params.get('extended', "False")
        extended = bool(util.strtobool(extended_raw))
        if extended:
            return CourseExtendedSerializer
        return CourseSerializer

    @action(detail=True, methods=['post'])
    def launch(self, request, *args, **kwargs):
        course = self.get_object()
        if course.series is None:
            logger.warning(f"Course {course.id} has no series. Couldn't check if it is payed.", extra={'course': course.__dict__})
            raise PermissionDenied("This course is not in a payed series.")
        if not course.is_payed(request.user):
            raise PermissionDenied("This course is not in a payed series.")
        response = self.launch_course_service.execute(course, request.user)
        read_serializer = self.get_serializer(response, many=False)
        return Response(read_serializer.data, status=status.HTTP_201_CREATED)


# this order of inheritance is needed to overwrite (patch) the method get_extra_action_url_map
class LabViewSet(ExtraActionsMixin, viewsets.ViewSet):
    # filter_backends and filterset_class will not be executed, they are just here to generate
    # a filter button in the autogenerated api web pages
    filter_backends = [CollectionFilterBackend]
    filterset_fields = ['is_running', 'is_saved', 'is_others']
    permission_classes = [IsAuthenticated]

    @inject
    def __init__(self,
                 labs_factory: ILabsFactory,
                 destroy_lab_service: IDestroyLabService,
                 resume_lab_service: IResumeLabService,
                 save_lab_service: ISaveLabService,
                 *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.labs_factory = labs_factory
        self.destroy_lab_service = destroy_lab_service
        self.resume_lab_service = resume_lab_service
        self.save_lab_service = save_lab_service

    def get_serializer_class(self):
        if self.action == "resume" or self.action == "save":
            return LaunchSerializer
        return LabSerializer

    def get_serializer(self, *args, **kwargs):
        serializer_class = self.get_serializer_class()
        kwargs.setdefault('context', self.get_serializer_context())
        return serializer_class(*args, **kwargs)

    def get_serializer_context(self):
        return {
            'request': self.request,
            'view': self
        }

    def filter_queryset(self, queryset):
        for backend in self.filter_backends:
            queryset = backend().filter(self.request, queryset, LabViewSet)
        return queryset

    # eventuell pro user cachen, und parameter hinzufügen für force refresh
    def get_queryset(self):
        def load_data():
            queryset = ModelCollection(Lab, self.labs_factory.populate_data(self.request.user))
            queryset = self.filter_queryset(queryset)
            return queryset
        return LazyModelCollection(Lab, load_data)

    def get_object(self):
        queryset = self.filter_queryset(self.get_queryset())
        # May raise a permission denied
        pk = self.kwargs['pk']
        try:
            int_pk = int(pk)
        except ValueError:
            raise NotFound()
        filtered = list(filter(lambda _lab: _lab.id == int_pk, queryset))
        if len(filtered) < 1:
            raise NotFound()
        if len(filtered) > 1:
            logger.warning(f"There is more than 1 lab with id {pk}")
        obj = filtered[0]
        self.check_object_permissions(self.request, obj)
        return obj

    def list(self, request):
        labs = self.get_queryset()
        serializer = LabSerializer(labs, many=True)
        return Response(serializer.data)

    def retrieve(self, request, pk=None):
        obj = self.get_object()
        serializer = LabSerializer(obj, many=False)
        return Response(serializer.data)

    def destroy(self, request, *args, **kwargs):
        # fist check if the user has access to this lab instance by getting the object
        instance = self.get_object()
        # now the user seems to have access to this lab instance
        # that means, that the user is the user of the lab or an admin
        self.destroy_lab_service.execute(instance)
        return Response(None, status.HTTP_204_NO_CONTENT)

    @action(detail=True, methods=['post'])
    def resume(self, request, *args, **kwargs):
        instance = self.get_object()
        out = self.resume_lab_service.execute(instance)
        serializer = self.get_serializer(out, many=False)
        return Response(serializer.data)

    @action(detail=True, methods=['post'])
    def save(self, request, *args, **kwargs):
        instance = self.get_object()
        out = self.save_lab_service.execute(instance)
        serializer = self.get_serializer(out, many=False)
        return Response(serializer.data)


class LabHistoryViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = LabHistory.objects.all().order_by('-id')
    serializer_class = LabHistorySerializer
    filterset_fields = ['course_id', 'action']

    def filter_queryset(self, queryset):
        queryset = super().filter_queryset(queryset)
        if is_admin(self.request):
            return queryset
        return queryset.filter(user=self.request.user)
